--- Module for set ring tone
--
-- @file    ringTone.lua
-- @author  Gennadiy Ganchev
-- @created 2016/10/31

--- @module ringTone
local ringTone = {}

----------------------------------------------------------------
-- Public interface
----------------------------------------------------------------
--- Preparing 'Alert-Info' SIP header with ringtone definition
-- @param ringTone   The user ring tone feature
-- @param callType   The call type value of current call
-- @return formatted 'Alert-Info' header for setting it via predial
function ringTone.getAlertHeader(ringTone, callType)
    -- update call type for silent ringtone
    local ringType = callType or ""
    if "silent" == ringTone then
        ringType = "silent"
    end
    
    --- set up default ringtone value 'Ring1.wav'
    local header = string.format("<http://127.0.0.1/Ring1.wav;info=%s>", ringType) 
    if ringTone then
        if ringTone:match("^fxs$") and "external" == callType then
            header = string.format("<http://127.0.0.1/Bellcore-dr4>")
        else
            header = string.format("<http://127.0.0.1/%s.wav;info=%s>", ringTone, ringType)
        end
    end
    return header
end

return ringTone