--- Processing operations in case using custom client services
-- 
-- @file    CustomExServiceStragegy.lua 
-- @author  Vyacheslav Khudan
-- @created 2016/07/08

--- @module CustomExServiceStragegy
local CustomExServiceStragegy = {}

----------------------------------------------------------------
-- Public interface
----------------------------------------------------------------
local strategy = {  -- meta class
    userAttrs  = nil	-- user attributes for current room
}

--- @see callOut.callOutService
function strategy:applicationCallOut(errorCallback, ...)
    local rv, err = require"exService.callOut.callOutService".initCall(self.userAttrs.uid, ...)
    return rv or errorCallback(err)
end


--- Object constructor
function CustomExServiceStragegy:new(userAttrs)
if "table" ~= type(userAttrs) then
		return false, "Invalid user attributes format"
	end
	
	-- processing room identification
	local cid = userAttrs.telephoneNumber 
	if not cid then
		return false, "Not found user extension"
	end
	
	local obj = {}
	setmetatable(obj, {__index = strategy})

	obj.userAttrs  = userAttrs
	obj.name	   = "Custom extended service"
	
	return obj
end

return CustomExServiceStragegy