--- Processing operations in case using extended services via API implementation
-- 
-- @file    APIExServiceStrategy.lua 
-- @author  Vyacheslav Khudan
-- @created 2015/07/09

--- @module PBXExServiceStrategy
local PBXExServiceStrategy = {}

----------------------------------------------------------------
-- Public interface
----------------------------------------------------------------
local strategy  	= require"IExServiceStrategy":new() -- meta class
strategy.userAttrs  = nil	-- user attributes for current room

--- @see @see description in IExServiceStrategy
-- @note loading API strategy as parent for WakeUp service
function strategy:serviceWakeUp(forbidCallback, val)
	local APIObj = require"APIExServiceStrategy":new(self.userAttrs)
	return APIObj:serviceWakeUp(forbidCallback, val)
end

--- Object constructor
function PBXExServiceStrategy:new(userAttrs)
if "table" ~= type(userAttrs) then
		return false, "Invalid user attributes format"
	end
	
	-- processing room identification
	local cid = userAttrs.telephoneNumber 
	if not cid then
		return false, "Not found user extension"
	end
	
	local obj = {}
	setmetatable(obj, {__index = strategy})

	obj.userAttrs  = userAttrs
	obj.name	   = "PBX extended service"
	
	return obj
end

return PBXExServiceStrategy