--- Asterisk accessor module
-- 
-- @file    Accessor.lua 
-- @author  Vyacheslav Khudan
-- @created 2016/08/30

--- @module Accessor
local Accessor = {} 

----------------------------------------------------------------
-- Public interface
----------------------------------------------------------------
function Accessor:new(cfg)
    if "table" ~= type(cfg) then
        return false
    end
    
    local driver = nil
	if "table" == type(cfg) then
        driver = require"driversFactory":new(cfg.options)
        driver = driver:instantiate(cfg.ident)
        if not driver then
            return false
        end
	end
    
    local obj   = {}
    obj.mDriver = driver
    
    function obj:put(key, val)
        return self.mDriver:put(key, val)
    end

    function obj:get(key)
        return self.mDriver:get(key)
    end

    function obj:del(key)
        if "table" == type(key) and "tree" == key.ident then
            self.mDriver:delTree(key.val)
        else
            self.mDriver:del(key)
        end
    end

	return obj
end

return Accessor
