--- Driver to retrive astdb access via dialplan functions 
-- 
-- @file	DialplanDriver.lua 
-- @author	Vyacheslav Khudan
-- @created 2016/08/31

--- @module DialplanDriver
local DialplanDriver = {}

----------------------------------------------------------------
-- Public interface
----------------------------------------------------------------
local driver  = require"IDriver":new()        -- meta class

--- @see description in IDriver
function driver:put(key, val)
    return channel.DB(key):set(val)
end

--- @see description in IDriver
function driver:get(key)
    return channel.DB(key):get()
end

--- @see description in IDriver
function driver:del(key)
    return channel.DB_DELETE(key):get()
end

--- @see description in IDriver
function driver:delTree(key)
    return app.DBdeltree(key)
end


--- Constructor
function DialplanDriver:new()
	local obj = {}
	setmetatable(obj, {__index = driver})
	
	return obj
end

return DialplanDriver



