--- Interface for all drivers
-- 
-- @file	IDriver.lua 
-- @author	Vyacheslav Khudan
-- @created 2016/08/31

--- @module IDriver
local IDriver = {}

----------------------------------------------------------------
-- public interface
----------------------------------------------------------------
local driver = {}

--- Put data to a storage
-- @param key           data key
-- @param val           data value
-- @return boolean status of operation
function driver:put(key,val)
end

--- Execute retrieving of data from external storage
-- @param key           data key
-- @return retrieved value otherwise nil
function driver:get(key)
end

--- Execute deleting of data
-- @param key           data key
function driver:del(key)
end

--- Execute deleting of data tree
-- @param key           data key, string
function driver:delTree(key)
end

--- Constructor
function IDriver:new()
	local obj = {}
	setmetatable(obj, {__index = driver})
    
	return obj
end

return IDriver

