--- Factory for concrete drivers implementations
-- 
-- @file	driversFactory.lua 
-- @author	Vyacheslav Khudan
-- @created 2016/08/30

--- @module driversFactory
local driversFactory = {}

----------------------------------------------------------------
-- Public interface
----------------------------------------------------------------
function driversFactory:new()
    local obj  = {}
    
    function obj:instantiate(ident)
        local rv = nil
        if "internal" == ident or "int" == ident then
            rv = require"DialplanDriver":new()
        elseif "external" == ident or "ext" == ident then
            rv = require"AMIDriver":new()
        end
	return rv
end
    
    return obj
end

return driversFactory

