--- Processor for predefined Kite calls
--
-- @file    kite.lua

local kite = {}

function kite.incomingCall(exten)
    channel["SECURITY_MASHUP"]:set("yes")
    channel["APPLICATION"]:set("KITE")
    
    if "echo" == exten then
        print("Call from Kite service to 'ECHO'")
        smartApp("Goto", "pbxservices", "echo", 1)
    else
        -- using from doamin for outgoing call 
        local fromHeader = channel.SIP_HEADER("From"):get() or ""
        local fromDomain = fromHeader:match("%<sip%:%w+%@([%w.-]+)%>")
        if fromDomain then
            channel["__SIPFROMDOMAIN"]:set(fromDomain)
        end
        print(string.format("Call from Kite service to '%s'", exten))
        smartApp("Goto", "kite", exten, 1)
    end
    
    return smartApp("Hangup", hcause.NORMAL)
end

function kite.outgoingCall(exten)
    if "yes" ~= channel.SIP_HEADER("X-To-Kite"):get() then
        logger:debug("Skipping not to Kite call (%s) ...", exten)
        return false 
    end
    
    local pbxSerial = require"core.pbxutils".pbxSerial()
    if not pbxSerial then
        print("Not found Kite peer for outgoing call")
        return smartApp("Hangup", hcause.FAILURE)
    end
    
    print(string.format("Call to Kite service at '%s@kite.wildix.com'", exten))
    smartApp("Dial", "SIP/"..pbxSerial.."/"..exten)
    
    return smartApp("Hangup", hcause.NORMAL)
end

return kite